\ main.fs

: period  500 # ;

: us ( n)  for  13 toggle, next ;
: pulse  12 output, 12 low, 5 # us 12 high,  5 # us 12 low, ;
: hedge  750 # us ;
: ready  12 input, begin 12 PIN sbis, again 100 # us ;

: bail pop drop ;
: measure ( 0 limit - count)
   for 1 #+ 5 # us 12 PIN sbis, bail ; next ;

: ping ( - n) pulse hedge ready 0 # 20000 # measure ; 

: /inch  variable # ;
: calibrate  ping 18 # / dup . /inch ! ;

: first  variable # ;
: nothing  first @ if [ char . ] # emit cr 0 # first !  then drop ;
: feet ( n)  [ char ' ] # -if
: inches ( n)  [ char " ] # then swap (u.) emit space ;
: ft,in ( n) 12 # u/mod feet inches ;
: tell ( n)  -120 # + -if 120 # + ft,in cr -1 # first ! ; then drop nothing ;

: wait  period for 1000 # for next next ;
: ins  ping /inch @ u/mod tell drop ;
: inches  -1 # first ! begin ins wait again

: say  ( n)  -300 # + -if 300 # + . cr -1 # first ! ; then drop nothing ;
: cms  ping 254 # /inch @ 100 # * */ say ;
: metric  -1 # first ! begin cms wait again

: default  37 # /inch ! ;
: go  default metric ;

